package Fiteiro;

import Fiteiro.Pessoa.*;
import Fiteiro.Venda.*;
import Fiteiro.Produto.*;
import Fiteiro.Util.*;


public class Fachada {

    private static Fachada            instancia;
    private CadastroProdutos  	      cadProdutos;
    private CadastroPessoas   	      cadUsuarios;
    private CadastroVendas            cadVendas;

    public Fachada() {
        initCadastros();
    }

    private void initCadastros() {
        RepositorioPessoasLista   listaU1 = new RepositorioPessoasLista();
        RepositorioProdutosLista  listaP1 = new RepositorioProdutosLista();
        RepositorioVendasLista    listaV1 = new RepositorioVendasLista();

        cadUsuarios = new CadastroPessoas(listaU1);
       	cadProdutos = new CadastroProdutos(listaP1);
       	cadVendas = new CadastroVendas(listaV1);
    }
      public static Fachada obterInstancia() {
	 if (instancia == null) {
	   instancia = new Fachada();
	 }
	 return instancia;
    }

/*
    public Fachada(CadastroProdutos cp, CadastroPessoas cu, CadastroVendas cv){
       	this.cadProdutos 	= cp;
        this.cadUsuarios 	= cu;
        this.cadVendas 		= cv;
   }
*/
  /************ METODOS DE USUARIO ******************/
    public void cadastrar(Usuario usuario) throws PessoaJaCadastradaException{
	this.cadUsuarios.cadastrar(usuario);
    }

    public void remover (Usuario usuario) throws PessoaNaoEncontradaException {
        this.cadUsuarios.remover(usuario);
    }

    public boolean existe(Usuario usuario){
        return this.cadUsuarios.existe(usuario);
    }

    public Pessoa retornar(Usuario usuario)throws PessoaNaoEncontradaException {
        return this.cadUsuarios.retornar(usuario);
    }

     public Pessoa procurar(Usuario usuario) throws PessoaNaoEncontradaException{
        return this.cadUsuarios.procurar(usuario);
    }

    public void atualizar(Usuario user1, Usuario user2)throws PessoaNaoEncontradaException{
        this.cadUsuarios.atualizar(user1,user2);
    }

    public RepositorioPessoas listaPessoas(String nome) throws PessoasNaoEncontradasException {
        return this.cadUsuarios.listaPessoas(nome);
    }

    public RepositorioPessoas listarTodasPessoas()throws NinguemEncontradoException{
        return this.cadUsuarios.listarTodasPessoas();
    }


  /************ METODOS DE PRODUTOS *****************/

    public void cadastrar(Produto prod) throws ProdutoJaCadastradoException {
        this.cadProdutos.cadastrar(prod);
    }

    public void remover(Produto prod)throws ProdutoNaoEncontradoException {
        this.cadProdutos.remover(prod);
    }

    public Produto procurar(Produto produto)throws ProdutoNaoEncontradoException {
        return this.cadProdutos.retornar(produto);
    }
    public Produto retornar(Produto prod) throws ProdutoNaoEncontradoException {
        return this.cadProdutos.retornar(prod);
    }

    public void atualizar(Produto prod1, Produto prod2) throws ProdutoNaoEncontradoException{
        this.cadProdutos.atualizar(prod1,prod2);
    }

    public void acrescentar(Produto prod, int quant) throws ProdutoNaoEncontradoException{
        this.cadProdutos.acrescentar(prod,quant);
    }

    public void diminuir(Produto prod, int quant)
            throws ProdutoNaoEncontradoException,
            QuantidadeInvalidaException {

        this.cadProdutos.diminuir(prod,quant);
    }

     public RepositorioProdutosLista listarTodosProdutos() throws NenhumProdutoEncontradoException{
        return this.cadProdutos.listarTodosProdutos();
    }

    /************ METODOS DE VENDA ********************/

    public void cadastrar(Venda venda) throws VendaJaCadastradaException {
        this.cadVendas.cadastrar(venda);
    }

    public void remover(Venda venda)throws VendaNaoEncontradaException{
        this.cadVendas.remover(venda);
    }

    public Venda retornar(Venda venda)throws VendaNaoEncontradaException{
        return this.cadVendas.retornar(venda);
    }

    public void atualizar(Venda vend1, Venda vend2) throws VendaNaoEncontradaException{
        this.cadVendas.atualizar(vend1,vend2);
    }




/******************************************************/

/*

	public static void main(String args[]){

		Fachada fachada;

       	CadastroPessoas cadastroU;
       	CadastroProdutos cadastroP;
       	CadastroVendas cadastroV;

        RepositorioPessoasLista   listaU1;
        RepositorioProdutosLista  listaP1;
        RepositorioVendasLista    listaV1;

        listaU1 = new RepositorioPessoasLista();
       	listaP1 = new RepositorioProdutosLista();
       	listaV1 = new RepositorioVendasLista();

       	cadastroU = new CadastroPessoas(listaU1);
       	cadastroP = new CadastroProdutos(listaP1);
       	cadastroV = new CadastroVendas(listaV1);

       	Endereco end = new Endereco("Rua de Barro","s/n","complemento.","ceasa",
                        "Recife","PE");

       	fachada = new Fachada(cadastroP, cadastroU, cadastroV);

	    Produto prod1;
       	Produto prod2;
       	Produto prod3;
       	Produto prod4;
       	Produto prod5;
       	Produto prod6;
       	Produto prod7;
       	Produto prod8;
       	Produto prod9;
       	Produto prod10;

       	Endereco end1;
       	Endereco end2;
       	Endereco end3;

       	Pessoa usr1;
       	Pessoa usr2;
       	Pessoa usr3;

        DadosComplementares comp1;
        DadosComplementares comp2;
        DadosComplementares comp3;

        RepositorioProdutosLista rep1;
        RepositorioProdutosLista rep2;
        RepositorioProdutosLista rep3;

        Venda vend1;
       	Venda vend2;
       	Venda vend3;


       	Pessoa pessoaTeste;
       	Produto produtoTeste;
       	Venda vendaTeste;


       	end1 = new Endereco("Rua de Barro","s/n","complemento.","ceasa",
                        "Recife","PE");
       	end2 = new Endereco("Rua Condado","92","complemento","Parnamirim",
                        "Recife","PE");
       	end3 = new Endereco("Rua Prof. Evaldo Otino","92","complemento","StrongHouse",
                        "Recife","PE");


        comp1 = new DadosComplementares("34532897","mcd@cin.ufpe.br","999999999");

        comp2 = new DadosComplementares("34268016","bcm@cin.ufpe.br","888888888");

        comp3 = new DadosComplementares("34532897","mss@cin.ufpe.br","777777777");


        usr1 = new Usuario("Marcelo Dantas", end1, "123456789", comp1);

        usr2 = new Usuario("Bruno Carvalho", end2, "987654321", comp2);

        usr3 = new Usuario("Muela Soja da Silva", end3,"123654987", comp3);

       fachada.cadastrar((Usuario)usr1);
       fachada.cadastrar((Usuario)usr2);
       fachada.cadastrar((Usuario)usr3);

    //imprimindo cadastro de Usuarios

       System.out.println("LISTANDO CADASTRO DE USUARIOS...");
       for(int i=1; i<=3; i++){

          if(i==1)
             pessoaTeste = fachada.retornar((Usuario)usr1);

          else if(i==2)
             pessoaTeste = fachada.retornar((Usuario)usr2);

          else
             pessoaTeste = fachada.retornar((Usuario)usr3);

          if(pessoaTeste != null){

             System.out.println("********************************");
             System.out.println("Cpf   	  :"+ pessoaTeste.getCpf());
             System.out.println("Nome     :"+ pessoaTeste.getNome());
             System.out.println("********************************");
             System.out.println("");
          }
       }


       prod1 = new Produto("chiclete", "001", 0.50,"Ploc",10);

       prod2 = new Produto("cigarro","002", 30.00, "endurecido",15);

       prod3 = new Produto("isqueiro","003", 5.00, "molhadinho",15);

       prod4 = new Produto("caneta","004",76.98, "enrugadinha",10 );

       prod5 = new Produto("lapis","005", 45.32, "azul",13);

       prod6 = new Produto("confeito","006",32.33, "Azedinho",20);

       prod7 = new Produto("barbeador","007",12.67, "fininho",10);

       prod8 = new Produto("pente","008",69.69, "longo",15);

       prod9 = new Produto("cana","009",66.78, "grossa",16);

       prod10 = new Produto("fosfu","010",10.23,"do bom",10);



       fachada.cadastrar(prod1);
       fachada.cadastrar(prod2);
       fachada.cadastrar(prod3);
       fachada.cadastrar(prod4);
       fachada.cadastrar(prod5);
       fachada.cadastrar(prod6);
       fachada.cadastrar(prod7);
       fachada.cadastrar(prod8);
       fachada.cadastrar(prod9);
       fachada.cadastrar(prod10);

    //imprimindo cadastro de produtos

       System.out.println("LISTANDO CADASTRO DE PRODUTOS...");
       for(int i=1; i<=10; i++){

          if(i==1)
              produtoTeste = fachada.retornar(prod1);

          else if(i==2)
              produtoTeste = fachada.retornar(prod2);

          else if(i==3)
              produtoTeste = fachada.retornar(prod3);

          else if(i==4)
              produtoTeste = fachada.retornar(prod4);

          else if(i==5)
              produtoTeste = fachada.retornar(prod5);

          else if(i==6)
              produtoTeste = fachada.retornar(prod6);

          else if(i==7)

              produtoTeste = fachada.retornar(prod7);

          else if(i==8)
              produtoTeste = fachada.retornar(prod8);

          else if(i==9)
              produtoTeste = fachada.retornar(prod9);

          else
              produtoTeste = fachada.retornar(prod10);

          if(produtoTeste != null){

             System.out.println("********************************");
             System.out.println("Codigo   :"+ produtoTeste.getCodigo());
             System.out.println("Nome     :"+ produtoTeste.getNome());
             System.out.println("Preco    :"+ produtoTeste.getPreco());
             System.out.println("********************************");
             System.out.println("");
          }
       }
       CadastroProdutos cesta1;
       CadastroProdutos cesta2;
       CadastroProdutos cesta3;


       rep1 = new RepositorioProdutosLista();
       rep2 = new RepositorioProdutosLista();
       rep3 = new RepositorioProdutosLista();


       cesta1 = new CadastroProdutos(rep1);
       cesta2 = new CadastroProdutos(rep2);
       cesta3 = new CadastroProdutos(rep3);

       cesta1.cadastrar(prod1);
       cesta1.cadastrar(prod2);
       cesta1.cadastrar(prod3);
       cesta2.cadastrar(prod4);
       cesta2.cadastrar(prod5);
       cesta2.cadastrar(prod6);
       cesta3.cadastrar(prod7);
       cesta3.cadastrar(prod8);
       cesta3.cadastrar(prod9);



    	vend1 = new Venda(((Usuario)usr1),cesta1);
       	   fachada.cadastrar(vend1);

	    vend2 = new Venda(((Usuario)usr2),cesta2);
	   	     fachada.cadastrar(vend2);

     	vend3 = new Venda(((Usuario)usr3),cesta3);
       	fachada.cadastrar(vend3);




    //imprimindo cadastro de vendas

       for(int i=1; i<=3; i++){

          if(i==1) {
             vendaTeste = fachada.retornar(vend1);

          }

          else if(i==2){
             vendaTeste = fachada.retornar(vend2);

          }
          else{
             vendaTeste = fachada.retornar(vend3);

           }

          if(vendaTeste != null){

             System.out.println("********************************");
             System.out.println("IMPRIMINDO VENDA: ");
             System.out.println("Pessoa  :"+ (vendaTeste.getPessoa()).getNome());
             System.out.println("********************************");
             System.out.println("");
          }
       }
  }

*/
}



