package Fiteiro.Pessoa;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class CadastroPessoas {

    private RepositorioPessoasLista usuarios;


    /**
     * Construtor da classe Cadastro
     *
     */
    public CadastroPessoas(RepositorioPessoasLista rep){
        usuarios = rep;
    }

    /**
     * Cadastra um usuario na lista de usuarios
     * @param       um usuario a ser cadastrado
     */
    public void cadastrar (Pessoa usuario) throws PessoaJaCadastradaException {
        if (!usuarios.existe(usuario))
            usuarios.inserir(usuario);
        else
          throw new PessoaJaCadastradaException("Cliente J Existente");
    }

     /**
     * Remove um usuario da lista de usuarios
     * @param       um usuario a ser removido
     */
    public void remover(Pessoa usuario) throws PessoaNaoEncontradaException{
        usuarios.remover(usuario);
    }

    /**
     * Retorna uma referencia de um usuario do cadastro, possibilitando uma
     * possivel mudana
     * @param       um usuario a ser pesquisado
     * @return      uma referencia para o usuario no cadastro
     */
    public Pessoa retornar(Pessoa usuario)throws PessoaNaoEncontradaException{
        return usuarios.procurar(usuario);
    }

    public boolean existe(Pessoa pessoa){
        return usuarios.existe(pessoa);
    }

    public Pessoa procurar(Pessoa pessoa) throws PessoaNaoEncontradaException{
        return usuarios.procurar(pessoa);
    }

    /**
     * Atualiza os dados de um usuario
     * @param usuarioAtual         usuario a ser procurado na lista
     * @param usuarioAtualizado    usuario que sera sobreposto ao procurado
     *                             caso o encontre
     */
    public void atualizar(Pessoa usuarioAtual, Pessoa usuarioAtualizado) throws PessoaNaoEncontradaException{
        Pessoa tempPessoa;

        tempPessoa = usuarios.procurar(usuarioAtual);
        usuarios.atualizar(tempPessoa, usuarioAtualizado);
    }

     /**
     * Lista todas as pessoas da lista que possuem uma determinada string
     * @param       a string a ser procurada no nome da pessoa
     * @return      uma lista contendo todas as ocorrencias desta procura
     */
    public RepositorioPessoas listaPessoas(String nome) throws PessoasNaoEncontradasException  {
        RepositorioPessoas retorno;

        retorno = this.usuarios.procuraPessoas(nome);

        return retorno;
    }

     /**
     * Lista todas as pessoas da lista
     * @return      uma lista contendo todas as ocorrencias desta procura
     */
     public RepositorioPessoas listarTodasPessoas() throws NinguemEncontradoException{
        RepositorioPessoas retorno;

        retorno = this.usuarios.listarTodasPessoas();

        return retorno;

     }

}
