package Fiteiro.Pessoa;
import Fiteiro.Util.Endereco;
import Fiteiro.Util.DadosComplementares;

//Title:        Fiteiro Virtual
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Equipe Fiteiro Virtual: Marcelo Dantas(mcd), Bruno Carvalho (bcm), Marcelo Andrade(mrra)
//Company:      UFPE
//Description:


public abstract class Pessoa {

    /**
    *Nome da Pessoa
    */
    private String nome;

    /**
    *Endereco da Pessoa
    */
    private Endereco endereco;

    /**
    * Cpf da Pessoa
    */
    private String cpf;

    /**
    * Dados complementares da Pessoa
    */
    private DadosComplementares complemento;


	/* Construtor da classe Pessoa
	*
	* @param nome	               	nome da pessoa
	* @param endereco   	        endereco da pessoa
    * @param cpf		        	cpf da pessoa
	*/
    public Pessoa (String nome, Endereco endereco, String cpf, DadosComplementares complemento) {
        this.nome = nome;
        this.cpf = cpf;
        this.endereco = endereco;
        this.complemento = complemento;
    }

     /**
     * Construtor Sobrecarregado
     *
     * @param nome	       	nome da pessoa
     * @param cpf		    cpf da pessoa
     */
    public Pessoa(String nome, String cpf){
        this.nome = nome;
        this.cpf = cpf;
    }

    /**
    * Metodo que retorna o nome da pessoa
    * @return 		uma string referente ao nome
    */
    public String getNome() {
	return this.nome;
    }

    /**
    * Metodo que muda o nome da pessoa
    * @param nome		nome da pessoa a ser mudado
    */
    public void setNome(String nome) {
        this.nome = nome;
    }

    /**
    * Metodo que retorna o enderco da pessoa
    * @return 		uma string referente ao endereco
    */
    public Endereco getEndereco() {
	return this.endereco;
    }

    /**
    * Metodo que muda o endereco da pessoa
    * @param endereco		endereco do pessoa a ser mudado
    */
    public void setEndereco (Endereco endereco) {
		this.endereco = endereco;
    }

    /**
    * Metodo que retorna o CPF da pessoa
    * @return 		uma string referente ao CPF
    */
    public String getCpf() {
	return this.cpf;
    }

    /**
    * Metodo que muda o CPF da pessoa
    * @param cpf		CPF da pessoa a ser mudado
    */
    public void setCpf(String cpf) {
	this.cpf = cpf;
    }

    public DadosComplementares getComplemento(){
    return this.complemento;
    }

    public void setComplemento(DadosComplementares complemento){
    this.complemento = complemento;
    }

    /**
    * Metodo que verifica se uma pessoa ie igual a outro comparando nome e cpf
    * @param pessoa 	Pessoa a ser comparada
    */
    public abstract boolean equals (Pessoa pessoa);


}
