package Fiteiro.Pessoa;

import Fiteiro.Util.Endereco;
import Fiteiro.Util.DadosComplementares;
import Fiteiro.Pessoa.*;

/**
 * Title:  Ecommerce - O Fiteiro Virtual
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class Usuario extends Pessoa{

    /**
	* Construtor da classe Usuario
	* @param nome	               	nome do usuario
	* @param endereco   	        endereco do usuario
	* @param cpf		        	cpf do usuario
    * @param complemento            complemento do usuario
	*/
    public Usuario (String nome, Endereco endereco, String cpf, DadosComplementares complemento) {
        super(nome, endereco, cpf, complemento);
    }

     /**
     * Construtor Sobrecarregado
     *
     * @param nome	        	nome do usuario
     * @param cpf			cpf do usuario
     */
    public Usuario(String nome, String cpf){
        super(nome, cpf);
    }

    /**
    * Metodo que verifica se um usuario ie igual a outro comparando nome e cpf
    * @param usuario 	Usuario a ser comparado
    */
    public boolean equals (Pessoa usuario){

        boolean retorno = false;
        if(usuario instanceof Usuario){
            if(this.getNome().equals(((Usuario) usuario).getNome()) &&
                      this.getCpf().equals(((Usuario)usuario).getCpf()))
                retorno = true;
        } else{
            throw new IllegalArgumentException("Pessoa no  do tipo Usuario");
        }
        return retorno;
    }

    public String toString(){
        String r = new String("Usuario [");
        r += "Nome =" + this.getNome() + ", ";
        r += "CPF =" + this.getCpf() + "]";
        return r;
    }

 }