package Fiteiro.Produto;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class CadastroProdutos {

    private RepositorioProdutosLista produtos;


    /**
     * Construtor da classe Cadastro
     *
     */
    public CadastroProdutos(RepositorioProdutosLista rep){
        produtos = rep;
    }

    /**
     * Cadastra um produto na lista de produtos
     * @param produto       um usuario a ser cadastrado
     */
    public void cadastrar(Produto produto) throws ProdutoJaCadastradoException {
        if (!produtos.existe(produto))
            produtos.inserir(produto);
        else{
            ProdutoJaCadastradoException e = new ProdutoJaCadastradoException("Produto J Cadastrado");
            throw e;
        }
    }

    /**
     * Remove um produto da lista de produtos
     * @param produto       um produto a ser removido
     */
    public void remover(Produto produto) throws ProdutoNaoEncontradoException{
        if(!produtos.existe(produto)) {
            ProdutoNaoEncontradoException e = new ProdutoNaoEncontradoException("Produto no Encontrado");
            throw e;
        } else {
            produtos.remover(produto);
        }
    }

    /**
     * Retorna uma referencia de um Produto do cadastro, possibilitando uma
     * possivel mudana
     * @param produto         um produto a ser pesquisado
     * @return tempProduto    uma referencia para o produto no cadastro
     */
    public Produto retornar(Produto produto) throws ProdutoNaoEncontradoException{
        Produto tempProduto = null;

        tempProduto = produtos.procurar(produto);
        if (tempProduto == null) {
            ProdutoNaoEncontradoException e = new ProdutoNaoEncontradoException("Produto no Encontrado");
            throw e;
        }

        return tempProduto;
    }


    public Produto procurar(Produto produto)throws ProdutoNaoEncontradoException {
        return produtos.procurar(produto);
    }

    /**
     * Atualiza os dados de um produto
     * @param produtoAtual         produto a ser procurado na lista
     * @param produtoAtualizado    produto que sera sobreposto ao procurado
     *                             caso o encontre
     */
    public void atualizar(Produto produtoAtual, Produto produtoAtualizado)
                                    throws ProdutoNaoEncontradoException{

        Produto tempProduto;

        tempProduto = produtos.procurar(produtoAtual);
        produtos.atualizar(tempProduto, produtoAtualizado);
    }

    public void acrescentar(Produto produto, int quantidade)
                      throws ProdutoNaoEncontradoException {

        this.acrescentar(produto,quantidade);
    }

    public void diminuir(Produto produto, int quantidade)
                         throws ProdutoNaoEncontradoException,
                         QuantidadeInvalidaException{

        this.diminuir(produto,quantidade);
    }

    public RepositorioProdutosLista listarTodosProdutos() throws NenhumProdutoEncontradoException {
          return this.listarTodosProdutos();
    }
}
