package Fiteiro.Produto;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class Produto {

    /**
     * Nome do Produto
     */
    private String nome;

    /**
     * Codigo do Produto
     */
    private String codigo;

    /**
     * Preco do Produto
     */
    private double preco;

    /**
     * Descricao do Produto
     */
    private String descricao;

    /**
     * Quantidade do Produto
     */
    private int quantidade;


    /**
     *  Descreve os produtos do e-commerce
     *  @param nome             nome do produto
     *  @param codigo           codigo que vai identificar o produto
     *  @param preco            preco do produto
     *  @param descricao        descreve as caracteristicas principais do produto
     *  @param quantidade       quantidade de itens do produto
     */
    public Produto(String nome, String codigo, double preco, String descricao,int quantidade) {
        this.nome = nome;
        this.codigo = codigo;
        this.preco = preco;
        this.descricao = descricao;
        this.quantidade = quantidade;

    }

    /**
     * Construtor sobrecarregado da classe Produto
     * @param codigo        codigo do produto
     */
    public Produto(String codigo) {
        this.codigo = codigo;
    }

    /**
    * Metodo para setar o nome do produto
    * @param nome       seta o nome do produto
    */
    public void setNome(String nome) {
        this.nome = nome;
    }

    /**
    * Metodo para setar o codigo do produto
    * @param codigo     seta o codigo do produto
    */
    public void setCodigo(String codigo) {
        this.codigo = codigo;
    }

    /**
    * Metodo para setar a descricao do produto
    * @param descricao      seta a descricao do produto
    */
    public void setDescricao(String descricao) {
      this.descricao = descricao;
    }

    /**
    * Metodo para setar o preco do produto
    * @return preco         preco do produto
    */
    public void setPreco(double preco) {
        this.preco = preco;
    }

    /**
    * Metodo para setar a quantidade do produto
    * @return quantidade         quantidade do produto
    */
    public void setQuantidade(int quantidade) {
        this.quantidade = quantidade;
    }

    /**
    * Metodo para retornar o nome do produto
    * @return nome      nome do produto
    */
    public String getNome() {
        return nome;
    }

    /**
    * Metodo para retornar o codigo do produto
    * @return codigo      codigo do produto
    */
    public String getCodigo() {
        return codigo;
    }

    /**
    * Metodo para retornar quantidade de itens do produto
    * @return quantidade      quantidade do produto
    */
    public int getQuantidade() {
        return quantidade;
    }

    /**
    * Metodo para retornar a descricao do produto
    * @return descricao         descricao do produto
    */
    public String getDescricao() {
        return descricao;
    }

    /**
    * Metodo para retornar o preco do produto
    * @return preco      preco do produto
    */
    public double getPreco() {
        return preco;
    }

    /**
    * Verifica se dois produtos sao iguais !
    * @param produto        produto a ser comparado
    * @return retorno
    */
    public boolean equals(Produto produto){
        boolean retorno = false;
            if (this.codigo.equals(produto.getCodigo()))
            retorno = true;
        return retorno;
    }

    /**
     * Converte o objeto produto numa String
     * @return r
     */
    public String toString(){
        String r = new String("Produto [");
        r += "Codigo = " + this.codigo + "]";
        return r;
    }


}


