package Fiteiro.Produto;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class RepositorioProdutosLista {

    private Produto produtoAtual;
    private RepositorioProdutosLista produtoProximo;



    public IteradorProdutos getIterador() {
        int qtd;
        IteradorProdutos retorno;
        Produto[] array;

        //iniciando a contagem dos elementos.
        RepositorioProdutosLista rpl = this;
        for (qtd = 0; rpl.produtoAtual != null; qtd++) {
            rpl = rpl.produtoProximo;
        }

        //iniciando preenchimento
        array = new Produto[qtd];
        rpl = this;
        for (int i = 0; i < qtd; i++) {
            array[i] = rpl.produtoAtual;
            rpl = rpl.produtoProximo;
        }

        retorno = new IteradorProdutosArray(array);

        return retorno;
    }

    /**
     * Insere um produto no repositrio
     * @param       Um produto que vai ser inserido
     */
    public void inserir(Produto produto) {
        if (this.produtoAtual == null) {
                this.produtoAtual = produto;
                produtoProximo = new RepositorioProdutosLista();
        } else {
               produtoProximo.inserir(produto);
        }
    }


     /**
     * Diz se um produto existe ou no em um repositrio
     * @param       Produto a ser pesquisada
     * @return      True se o produto for encontrada, false caso contrrio
     *
     */
    public boolean existe(Produto produto){
        boolean resultado;

        if (this.produtoAtual == null) {
            resultado = false;
        } else {
            if (this.produtoAtual.equals(produto)) {
                resultado = true;
            } else {
                resultado = produtoProximo.existe(produto);
            }
        }
        return resultado;
    }

     /**
     * Remove produto do repositrio
     * @param       produto a ser excluido
     */
    public void remover(Produto produto) throws ProdutoNaoEncontradoException{

        if (this.produtoAtual != null) {
            if (this.produtoAtual.equals(produto) ) {
                this.produtoAtual = produtoProximo.produtoAtual;
                this.produtoProximo = produtoProximo.produtoProximo;
            } else {
                produtoProximo.remover(produto);
            }
        }
        else {
            ProdutoNaoEncontradoException e = new ProdutoNaoEncontradoException("Produto No Cadastrado");
            throw e;
        }
    }

   /**
     * Busca por produtos atraves do codigo.
     * @param       Codigo do produto
     * @return      Produto do repositrio
     */
    public Produto procurar(Produto produto)throws ProdutoNaoEncontradoException {
        Produto retorno = null;

        if (this.produtoAtual != null) {
            if (this.produtoAtual.equals(produto)) {
                retorno  = this.produtoAtual;
           } else {
                retorno = this.produtoProximo.procurar(produto);
           }
        }

        if(retorno == null){
            ProdutoNaoEncontradoException e = new ProdutoNaoEncontradoException("Produto no Encontrado");
            throw e;
        }

        return retorno;
    }

     /**
     * Atualiza um produto.
     * @param atualProduto           o produto que sera procurado na lista
     * @param modificadoProduto      o produto que ira sobrepor o produto procurado
     */
    public void atualizar(Produto atualProduto, Produto modificadoProduto)
                                    throws ProdutoNaoEncontradoException {

        Produto temporarioProduto;

        temporarioProduto = this.procurar(atualProduto);
        temporarioProduto.setCodigo(modificadoProduto.getCodigo());
        temporarioProduto.setNome(modificadoProduto.getNome());
        temporarioProduto.setPreco(modificadoProduto.getPreco());
        temporarioProduto.setDescricao(modificadoProduto.getDescricao());
        temporarioProduto.setQuantidade(modificadoProduto.getQuantidade());
    }

    public void acrescentar(Produto produto, int quantidade)
                        throws ProdutoNaoEncontradoException{

        Produto temporarioProduto;

        temporarioProduto = this.procurar(produto);
        produto.setQuantidade(temporarioProduto.getQuantidade() + quantidade);
    }


    public void diminuir(Produto produto, int quantidade)
                  throws ProdutoNaoEncontradoException,
                         QuantidadeInvalidaException{

        Produto temporarioProduto;

        temporarioProduto = this.procurar(produto);

        if (temporarioProduto.getQuantidade() >= quantidade)
            produto.setQuantidade(temporarioProduto.getQuantidade() - quantidade);
        else{
            QuantidadeInvalidaException e = new QuantidadeInvalidaException(quantidade);
            throw e;
        }
    }

    public RepositorioProdutosLista listarTodosProdutos() throws NenhumProdutoEncontradoException {
        RepositorioProdutosLista temp;
        RepositorioProdutosLista lista = new RepositorioProdutosLista();

        temp = this;

        while(temp.produtoAtual != null){

           if(true){
                lista.inserir(temp.produtoAtual);
                temp = temp.produtoProximo;
           } else {
                temp = temp.produtoProximo;
           }

        }
        if(lista.produtoAtual == null){
            NenhumProdutoEncontradoException e = new NenhumProdutoEncontradoException("No foram encontrados Produtos");
            throw e;
        }

        return lista;
  }

}
