package Fiteiro.Util;

//Title:        Fiteiro Virtual
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Equipe Fiteiro Virtual: Marcelo Dantas(mcd), Bruno Carvalho (bcm), Marcelo Andrade(mrra)
//Company:      UFPE
//Description:

public class Endereco {

	/**
	*Nome da rua do Usuario
	*/
	private String rua;

	/**
	*Numero da casa do Usuario
	*/
	private String numero;

	/**
	*Complemento do endereco do Usuario
	*/
	private String complemento;

	/**
	*bairro do Usuario
	*/
	private String bairro;

	/**
	*Cidade do Usuario
	*/
	private String cidade;

	/**
	*Estado (U.F.) do Usuario
	*/
	private String estado;

	/**
	* Construtor da classe Endereco
	*
	* @param rua  		rua do usuario
	* @param numero	   	numero do usuario
	* @param complemento  	complemento do endereco do usuario
	* @param bairro		bairro do usuario
	* @param cidade		cidade do usuario
	* @param estado		estado (U.F.) do usuario
	*/
	public Endereco (String rua, String numero, String complemento, String bairro, String cidade, String estado) {

		this.rua = rua;
		this.numero = numero;
		this.complemento = complemento;
		this.bairro = bairro;
		this.cidade = cidade;
		this.estado = estado;

	}

	/**
	* Metodo que retorna o nome da rua do usuario
	*
	* @return 		uma string referente a rua
	*/
	public String getRua() {
		return this.rua;
	}

	/**
	* Metodo que muda o nome da rua do usuario
	*
	* @param rua		nome da rua do usuario a ser mudado
	*/
	public void setRua(String rua) {
		this.rua = rua;
	}

	/**
	* Metodo que retorna o numero da casa do usuario
	*
	* @return 		uma string referente ao numero da casa do usuario
	*/
	public String getNumero() {
		return this.numero;
	}

	/**
	* Metodo que muda o numero da casa do usuario
	*
	* @param numero		numero da casa do usuario a ser mudado
	*/
	public void setNumero(String numero) {
		this.numero = numero;
	}

	/**
	* Metodo que retorna o complemento do endereco do usuario
	*
	* @return 		uma string referente ao complemento do endereco do usuario
	*/
	public String getComplemento() {
		return this.complemento;
	}

	/**
	* Metodo que muda o complemento do endereco do usuario
	*
	* @param complemento	complemento do endereco do usuario a ser mudado
	*/
	public void setComplemnto(String complemento) {
		this.complemento = complemento;
	}

	/**
	* Metodo que retorna o nome do bairro do usuario
	*
	* @return 		uma string referente ao bairro do usuario
	*/
	public String getBairo() {
		return this.bairro;
	}

	/**
	* Metodo que muda o nome do bairro do usuario
	*
	* @param bairro		nome do bairro do usuario a ser mudado
	*/
	public void setBairro(String bairro) {
		this.bairro = bairro;
	}

	/**
	* Metodo que retorna o nome cidade do usuario
	*
	* @return 		uma string referente ao nome cidade do usuario
	*/
	public String getCidade() {
		return this.cidade;
	}

	/**
	* Metodo que muda o nome da cidade do usuario
	*
	* @param cidade		nome da cidade do usuario a ser mudado
	*/
	public void setCidade(String cidade) {
		this.cidade = cidade;
	}

	/**
	* Metodo que retorna o estado do usuario
	*
	* @return 		uma string referente ao estado (U.F.) do usuario
	*/
	public String getEstado() {
		return this.estado;
	}

	/**
	* Metodo que muda o nome do estado (U.F.) do usuario
	*
	* @param estado		nome do estado (U.F.) do usuario a ser mudado
	*/
	public void setEstado(String estado) {
		this.estado = estado;
	}


}