package Fiteiro.Venda;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class CadastroVendas {

    private RepositorioVendasLista vendas;


    /**
     * Construtor da classe Cadastro
     *
     */
    public CadastroVendas(RepositorioVendasLista rep){
        vendas = rep;
    }

    /**
     * Cadastra um venda na lista de vendas
     * @param       um venda a ser cadastrado
     */
    public void cadastrar (Venda venda) throws VendaJaCadastradaException{
        if (!vendas.existe(venda))
            vendas.inserir(venda);
        else{
            VendaJaCadastradaException e = new VendaJaCadastradaException(venda);
            throw e;
        }
    }

    /**
     * Remove um venda da lista de vendas
     * @param       um venda a ser removido
     */
    public void remover(Venda venda) throws VendaNaoEncontradaException{
        if(!vendas.existe(venda)) {
            VendaNaoEncontradaException e =  new VendaNaoEncontradaException(venda);
            throw e;
        } else {
            vendas.remover(venda);
        }
    }

    /**
     * Retorna uma referencia de um venda do cadastro, possibilitando uma
     * possivel mudana
     * @param       um venda a ser pesquisado
     * @return      uma referencia para o venda no cadastro
     */
    public Venda retornar(Venda venda) throws VendaNaoEncontradaException {
        Venda tempVenda = null;

        tempVenda = vendas.procurar(venda);
        if (tempVenda == null) {
            VendaNaoEncontradaException e =  new VendaNaoEncontradaException(venda);
            throw e;
        }

        return tempVenda;
    }

    /**
     * Atualiza os dados de um venda
     * @param vendaAtual         venda a ser procurado na lista
     * @param vendaAtualizado    venda que sera sobreposto ao procurado
     *                             caso o encontre
     */
    public void atualizar(Venda vendaAtual, Venda vendaAtualizado)
                                throws VendaNaoEncontradaException{

        Venda tempVenda;

        tempVenda = vendas.procurar(vendaAtual);
        vendas.atualizar(tempVenda, vendaAtualizado);
    }
}

