package Fiteiro.Venda;

/**
 * Title:  Ecommerce - O Fiteiro Virtual
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class RepositorioVendasLista {

    private Venda vendaAtual;
    private RepositorioVendasLista vendaProxima;


    /**
     * Retorna uma lista de Vendas
     * @return      Um array de Vendas
     */
    public Venda[] getIterador() {
        RepositorioVendasLista temp;
        Venda[] retorno = new Venda[100];
        int count=0;

        temp = this;
        while (temp.vendaAtual != null) {
            retorno[count] = temp.vendaAtual;
            temp = temp.vendaProxima;
            count++;
        }

        return retorno;
    }



     /**
     * Insere um venda no repositrio
     * @param       Um venda que vai ser inserido
     */
    public void inserir (Venda venda){
        if (this.vendaAtual == null) {
                this.vendaAtual = venda;
                vendaProxima = new RepositorioVendasLista();
        } else {
               vendaProxima.inserir(venda);
        }
    }

        /**
     * Diz se um venda existe ou no em um repositrio
     * @param       Venda a ser pesquisada
     * @return      True se o venda for encontrada, false caso contrrio
     *
     */
    public boolean existe(Venda venda){
        boolean resultado;

        if (this.vendaAtual == null) {
            resultado = false;
        } else {
            if (this.vendaAtual.equals(venda)) {
                resultado = true;
            } else {
                resultado = vendaProxima.existe(venda);
            }
        }
        return resultado;
    }

     /**
     * Exclui venda do repositriio
     * @param       venda a ser excluido
     */
    public void remover(Venda venda) throws VendaNaoEncontradaException{

        if (this.vendaAtual != null) {
            if (this.vendaAtual.equals(venda) ) {
                this.vendaAtual = vendaProxima.vendaAtual;
                this.vendaProxima = vendaProxima.vendaProxima;
            } else {
                vendaProxima.remover(venda);
            }
        }
        else {
            VendaNaoEncontradaException e = new VendaNaoEncontradaException(venda);
            throw e;
        }
    }

    /**
     * Retorna uma referncia para um venda do repositrio, podendo
     * assim modific-la.
     * @param       Venda a ser pesquisado.
     * @return      Venda do repositrio
     */
    public Venda procurar(Venda venda) throws VendaNaoEncontradaException {
        Venda retorno = null;

        if (this.vendaAtual != null) {
            if (this.vendaAtual.equals(venda)) {
                retorno  = this.vendaAtual;
           } else {
                retorno = this.vendaProxima.procurar(venda);
           }
        }

        if(retorno == null){
             VendaNaoEncontradaException  e = new VendaNaoEncontradaException(venda);
             throw e;
        }

        return retorno;
    }

    /**
     * Atualiza um venda.
     * @param atualVenda           o venda que sera procurado na lista
     * @param modificadaVenda      o venda que ira sobrepor o venda procurada
     */
    public void atualizar( Venda atualVenda, Venda modificadaVenda ) throws VendaNaoEncontradaException{
        Venda temporariaVenda;

        temporariaVenda = this.procurar(atualVenda);

        temporariaVenda.setPessoa(modificadaVenda.getPessoa());
        temporariaVenda.setCesta(modificadaVenda.getCesta());

    }





}