package Fiteiro.Venda;
import Fiteiro.Produto.*;
import Fiteiro.Pessoa.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class Venda {


    /**
     * Usuario que efetuara a compra
     */
    private Pessoa pessoa;

    /**
     * Produtos a serem comprados
     */
    private CadastroProdutos cesta;


    /**
     * Construtor da Classe venda
     */
    public Venda(Pessoa pessoa, CadastroProdutos cesta){
        this.pessoa = pessoa;
        this.cesta = cesta;
    }


    public void setPessoa(Pessoa pessoa){
        this.pessoa = pessoa;
    }

    public void setCesta(CadastroProdutos cesta){
        this.cesta = cesta;
    }

    public Pessoa getPessoa(){
        return pessoa;
    }

    public CadastroProdutos getCesta(){
        return cesta;
    }

    public void inserir(Produto produto) throws ProdutoJaCadastradoException {
        this.cesta.cadastrar(produto);
    }

    public void remover(Produto produto) throws ProdutoNaoEncontradoException {
        this.cesta.remover(produto);
    }

    public void acrescentar(Produto produto, int quantidade)
                          throws ProdutoNaoEncontradoException{

        this.cesta.acrescentar(produto,quantidade);
    }

    public void diminuir(Produto produto, int quantidade)
                          throws ProdutoNaoEncontradoException,
                                 QuantidadeInvalidaException{
        this.cesta.diminuir(produto,quantidade);
    }

    public void atualizar(Produto produtoAtual, Produto produtoAtualizado)
                                     throws ProdutoNaoEncontradoException{
        this.cesta.atualizar(produtoAtual,produtoAtualizado);
    }


}